// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.21.12
// source: proto/master/payment/balance.proto

package payment

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// BalanceServiceClient is the client API for BalanceService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type BalanceServiceClient interface {
	CreateBalance(ctx context.Context, in *BalancePaymentRequest, opts ...grpc.CallOption) (*Balance, error)
	CreditBalance(ctx context.Context, in *BalanceMutationRequest, opts ...grpc.CallOption) (*Balance, error)
	DebitBalance(ctx context.Context, in *BalanceMutationRequest, opts ...grpc.CallOption) (*Balance, error)
	GetBalanceByID(ctx context.Context, in *BalanceIdentifierRequest, opts ...grpc.CallOption) (*Balance, error)
	GetBalanceByUserID(ctx context.Context, in *BalanceIdentifierByUserIDRequest, opts ...grpc.CallOption) (*Balance, error)
	GetListBalance(ctx context.Context, in *BalanceFilterQuery, opts ...grpc.CallOption) (*ListBalance, error)
}

type balanceServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewBalanceServiceClient(cc grpc.ClientConnInterface) BalanceServiceClient {
	return &balanceServiceClient{cc}
}

func (c *balanceServiceClient) CreateBalance(ctx context.Context, in *BalancePaymentRequest, opts ...grpc.CallOption) (*Balance, error) {
	out := new(Balance)
	err := c.cc.Invoke(ctx, "/master.payment.BalanceService/CreateBalance", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *balanceServiceClient) CreditBalance(ctx context.Context, in *BalanceMutationRequest, opts ...grpc.CallOption) (*Balance, error) {
	out := new(Balance)
	err := c.cc.Invoke(ctx, "/master.payment.BalanceService/CreditBalance", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *balanceServiceClient) DebitBalance(ctx context.Context, in *BalanceMutationRequest, opts ...grpc.CallOption) (*Balance, error) {
	out := new(Balance)
	err := c.cc.Invoke(ctx, "/master.payment.BalanceService/DebitBalance", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *balanceServiceClient) GetBalanceByID(ctx context.Context, in *BalanceIdentifierRequest, opts ...grpc.CallOption) (*Balance, error) {
	out := new(Balance)
	err := c.cc.Invoke(ctx, "/master.payment.BalanceService/GetBalanceByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *balanceServiceClient) GetBalanceByUserID(ctx context.Context, in *BalanceIdentifierByUserIDRequest, opts ...grpc.CallOption) (*Balance, error) {
	out := new(Balance)
	err := c.cc.Invoke(ctx, "/master.payment.BalanceService/GetBalanceByUserID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *balanceServiceClient) GetListBalance(ctx context.Context, in *BalanceFilterQuery, opts ...grpc.CallOption) (*ListBalance, error) {
	out := new(ListBalance)
	err := c.cc.Invoke(ctx, "/master.payment.BalanceService/GetListBalance", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// BalanceServiceServer is the server API for BalanceService service.
// All implementations must embed UnimplementedBalanceServiceServer
// for forward compatibility
type BalanceServiceServer interface {
	CreateBalance(context.Context, *BalancePaymentRequest) (*Balance, error)
	CreditBalance(context.Context, *BalanceMutationRequest) (*Balance, error)
	DebitBalance(context.Context, *BalanceMutationRequest) (*Balance, error)
	GetBalanceByID(context.Context, *BalanceIdentifierRequest) (*Balance, error)
	GetBalanceByUserID(context.Context, *BalanceIdentifierByUserIDRequest) (*Balance, error)
	GetListBalance(context.Context, *BalanceFilterQuery) (*ListBalance, error)
	mustEmbedUnimplementedBalanceServiceServer()
}

// UnimplementedBalanceServiceServer must be embedded to have forward compatible implementations.
type UnimplementedBalanceServiceServer struct {
}

func (UnimplementedBalanceServiceServer) CreateBalance(context.Context, *BalancePaymentRequest) (*Balance, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateBalance not implemented")
}
func (UnimplementedBalanceServiceServer) CreditBalance(context.Context, *BalanceMutationRequest) (*Balance, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreditBalance not implemented")
}
func (UnimplementedBalanceServiceServer) DebitBalance(context.Context, *BalanceMutationRequest) (*Balance, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DebitBalance not implemented")
}
func (UnimplementedBalanceServiceServer) GetBalanceByID(context.Context, *BalanceIdentifierRequest) (*Balance, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetBalanceByID not implemented")
}
func (UnimplementedBalanceServiceServer) GetBalanceByUserID(context.Context, *BalanceIdentifierByUserIDRequest) (*Balance, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetBalanceByUserID not implemented")
}
func (UnimplementedBalanceServiceServer) GetListBalance(context.Context, *BalanceFilterQuery) (*ListBalance, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetListBalance not implemented")
}
func (UnimplementedBalanceServiceServer) mustEmbedUnimplementedBalanceServiceServer() {}

// UnsafeBalanceServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to BalanceServiceServer will
// result in compilation errors.
type UnsafeBalanceServiceServer interface {
	mustEmbedUnimplementedBalanceServiceServer()
}

func RegisterBalanceServiceServer(s grpc.ServiceRegistrar, srv BalanceServiceServer) {
	s.RegisterService(&BalanceService_ServiceDesc, srv)
}

func _BalanceService_CreateBalance_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BalancePaymentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BalanceServiceServer).CreateBalance(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.payment.BalanceService/CreateBalance",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BalanceServiceServer).CreateBalance(ctx, req.(*BalancePaymentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _BalanceService_CreditBalance_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BalanceMutationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BalanceServiceServer).CreditBalance(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.payment.BalanceService/CreditBalance",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BalanceServiceServer).CreditBalance(ctx, req.(*BalanceMutationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _BalanceService_DebitBalance_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BalanceMutationRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BalanceServiceServer).DebitBalance(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.payment.BalanceService/DebitBalance",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BalanceServiceServer).DebitBalance(ctx, req.(*BalanceMutationRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _BalanceService_GetBalanceByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BalanceIdentifierRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BalanceServiceServer).GetBalanceByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.payment.BalanceService/GetBalanceByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BalanceServiceServer).GetBalanceByID(ctx, req.(*BalanceIdentifierRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _BalanceService_GetBalanceByUserID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BalanceIdentifierByUserIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BalanceServiceServer).GetBalanceByUserID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.payment.BalanceService/GetBalanceByUserID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BalanceServiceServer).GetBalanceByUserID(ctx, req.(*BalanceIdentifierByUserIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _BalanceService_GetListBalance_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BalanceFilterQuery)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BalanceServiceServer).GetListBalance(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/master.payment.BalanceService/GetListBalance",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BalanceServiceServer).GetListBalance(ctx, req.(*BalanceFilterQuery))
	}
	return interceptor(ctx, in, info, handler)
}

// BalanceService_ServiceDesc is the grpc.ServiceDesc for BalanceService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var BalanceService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "master.payment.BalanceService",
	HandlerType: (*BalanceServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateBalance",
			Handler:    _BalanceService_CreateBalance_Handler,
		},
		{
			MethodName: "CreditBalance",
			Handler:    _BalanceService_CreditBalance_Handler,
		},
		{
			MethodName: "DebitBalance",
			Handler:    _BalanceService_DebitBalance_Handler,
		},
		{
			MethodName: "GetBalanceByID",
			Handler:    _BalanceService_GetBalanceByID_Handler,
		},
		{
			MethodName: "GetBalanceByUserID",
			Handler:    _BalanceService_GetBalanceByUserID_Handler,
		},
		{
			MethodName: "GetListBalance",
			Handler:    _BalanceService_GetListBalance_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "proto/master/payment/balance.proto",
}
